let {join} = require('path')
let {readdirSync,lstatSync} = require('fs')
module.exports = class {
   constructor(app,routsPath) {
      this.routes = []
      this.mwRoutes = []
      this.getFilesList(routsPath)
      this.addRoutes(app)
   }
  
   getFilesList(dir,filelist = [],root,files) {
      if(root == undefined) root = dir
      if(!lstatSync(dir).isDirectory()) files = [dir]
      else files = readdirSync(dir)
      files.forEach(file => {
         let path = join(dir,file)
         if(lstatSync(path).isDirectory()) filelist = this.getFilesList(path,filelist,root)
         else {
            if(path.match(/(get|post|put|patch|delete)\.js$/)) {
               let { route,privat } = this.getRoute(path,root)
               if(!route.includes('.')) {
                  let parts = route.split('/')
                  route = route.split('/').map((part,i) => i==parts.length-1 ? '.'+part : part).join('/')
               }
               let array = route.split('.')
               route = array[0]
               let method = array[1]
               this.routes.push({privat,route,path,method})
            } else if(file.match(/^\#?mw\.js$/)) {
               let { route,privat } = this.getRoute(path,root,file)
               this.mwRoutes.push({privat,route,path})
            }
            else if(file.match(/^\#?router\.js$/)) 
               this.addRouter(path,root)
         }
      });
      return filelist
   }

   getRoute(path,root,file,route) {
      let privat
      if(file) {
         route = path.replace(file,'')
         privat = file.match(/\#/)? true : false
      } else privat = path.match(/\#/)? true : false
      route = path.replace(root,'').replace(/\\/g,'/').replace('.js','').replace(/\$/g,':').replace(/\#/g,'')
      route = route.replace(/mw|router$/,'')
      return {privat,route}
   }

   addRouter(path,root) {
      let {route,privat} = this.getRoute(path,root)
      let routes = require(path)
      routes = routes.sort((a,b) => b.route > a.route ? 1 : -1)
      routes.forEach(obj => {
         let {url,method,path} = obj
         url = (route+url).replace(/\/\//g,'/').replace(/\/$/,'')
         this.routes.push({privat,route:url,path,method})
      });
   }

   addRoutes(app) {
      this.routes = this.routes.sort((a,b) => b.route > a.route ? 1 : -1)
      this.routes.forEach(obj => {
         let {privat,route,path,method} = obj
         let mw = this.mwRoutes.filter(mwObj => {
            if(route.startsWith(mwObj.route)) {
               if(mwObj.privat && route.replace(mwObj.route,'').split('/').length <= 1) return mwObj
               else if(!mwObj.privat) return mwObj
            }
         })
         let array = [(req,res,next) => {
            req.routes = this.routes
            req.private = privat; 
            return next()
         }]
         // mw = mw.sort((a,b) => b.path > a.path ? 1 : -1)
         mw.forEach(obj => this.mwToArray(obj.path,array))

         array = this.mwToArray(path,array)
         app[method](route,array)
      });
   }
 
   mwToArray(path,array,fn) {
      if(path !== undefined) {
         if(typeof path == 'string') fn = require(path)
         else fn = path
         if(!Array.isArray(fn)) array.push(fn)
         else array = [...array,...fn]
      }
      return array
   }
}