const mime = require('mime-types')
let {join} = require('path')
let {existsSync} = require('fs')

let root = join(__dirname,'..','..')

module.exports = function checkStatic(req,res) {
   let {url,statics} = req
   url = url.split('?')[0]
   if(statics) {
      let staticKeys = Object.keys(statics)
      staticKeys = staticKeys.sort((a,b) => b > a ? 1 : -1)
      let filePath = false
      for(let i=0; i<staticKeys.length; i++) {
         let route = staticKeys[i]
         let path = statics[route]
         path = join(root,...path.split('/'))
         if(url.startsWith(route)) {
            let isFilePath = join(path,url.replace(route,''))
            if(existsSync(isFilePath)) {
               filePath = isFilePath
               break
            }
         }
      }
      if(filePath) {
         let type = mime.lookup(filePath)
         res.setHeader('content-type', type);
         return res.sendFile(filePath)
      }
      else return res.status(404).end('Not found')
   }
}
